package com.dbxml.db.enterprise.dbfiler;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: DBFilerPool.java,v 1.4 2004/04/14 21:14:58 bradford Exp $
 */

import com.dbxml.util.ObjectPool;
import com.dbxml.util.Poolable;
import java.sql.Connection;
import java.sql.DriverManager;
import java.util.Properties;

/**
 * DBFilerPool is a Connection Pool implementation for the DBFiler
 * class.
 */

public final class DBFilerPool extends ObjectPool {
   private String url;
   private String user;
   private String password;
   private Properties props;

   public DBFilerPool(String url, String user, String password) {
      this.url = url;
      this.user = user;
      this.password = password;
   }

   public DBFilerPool(String url, Properties props) {
      this.url = url;
      this.props = props;
   }

   public DBFilerPool(String url) {
      this.url = url;
   }

   public Poolable createObject() {
      try {
         Connection conn;
         if ( user != null )
            conn = DriverManager.getConnection(url, user, password);
         else if ( props != null )
            conn = DriverManager.getConnection(url, props);
         else
            conn = DriverManager.getConnection(url);
         return new DBFilerConnection(conn);
      }
      catch ( Exception e ) {
         e.printStackTrace(System.err);
         return null;
      }
   }
}

